--- 
title: "Backup : Mettre en place un systeme de backup complet"
date: 2021-07-01
tags: 
- restic 
- nextcloud
- gitea
categories : 
- commandline 
draft: false 
description : "Configuration d'un systeme de backup"
--- 

# Prélude

Tout le monde le sait, avoir des backup c'est important. Mais comment procéder ? Que faut-il sauvegarder ? Avec quel outil ? Ou faire ses backups ? Comment superviser ses sauvegardes ? Avec quel mécanisme assurer la rotation, les logs etc... ?

Nous allons donc aborder l'ensemble de ces points, apporter une réponse (mais pas LA réponse).

Cet article évoluera en fonction des besoins de sauvegardes. Il ne s'agit pas de mettre en place une solution d'entreprise, mais une solution personnelle pour un serveur dédié qui héberge des services.

On ne va donc pas assurer une sauvegarde globale, mais plutôt une sauvegarde par type de service.

# Sinopsis de la solution 
  * créer un compte backup
  * créer un groupe backup
  * créer un répertoire backup appartenant au groupe backup
  * forcer les droits des fichiers du répertoire pour qu'ils soient lisibles et supprimables par tous les membres du groupe backup
  * pour chaque service créer un script de sauvegarde et un timer systemd pour sauvegarder localement
  * un script de sauvegarde inclus un export des données vers un dépot restic distant, et la purge des fichiers
  * mettre en place un mécanisme d'alerting en cas d'erreur de sauvegarde

Les liens intéressant :
pour une sauvegarde de gitea https://gist.github.com/sinbad/4bb771b916fa8facaf340af3fc49ee43
pour une sauvegarde de nextcloud https://help.nextcloud.com/t/rsync-to-cloud-storage-for-backups/43574


