---
date: 2022-07-17
author: Alexandre LUCAZEAU
title: Grafana un assistant pour tout
tags:
- grafana
- data sciences
- decision science
categories:
- grafana
draft: false
description: "Grafana mon assistant commercial"
---

Dans le monde de l'IT, **Grafana** est très connu pour ses capacités de visualisation de
données de supervisions.

Il est généralement couplé à **Prometheus** ou à **Influxdb**.

Cette hégémonie dans la représentation des données systèmes, cache - un peu - un autre
usage : la représentation de données diverses, comme des données commerciales.

**Grafana** est un outil de consultation, de transformation et de visualisation de
données. C'est un outil libre, gratuit qui fonctionne avec des données temporelles.
A partir de sources de données, il vous simplifie leur représentation graphique, y
compris en y applicant des calculs ou transformations. Il fonctionne comme un serveur
web.

La partie visualisation est basée sur des __dashboards__ 

La partie source peut-être un fichier csv, une base temporelle, ou une base de données
relationnelle, mais pas que.

Sans offrir la capacité de transformation/manipulation d'un outil comme **R**,
**Grafana** est en mesure de vous accompagner dans votre gestion commerciale
quotidienne, que vous soyez une petite entreprise ou une PME. 

Pourquoi **Grafana** est une piste pour vous accompagner dans votre gestion commerciale
? Pourquoi ne pas utiliser directement un ERP ? Pourquoi ne pas rester sur mon fichier
xls que j'utilise depuis des années ?
Un ERP vous affiche des données jugées interessantes par son concepteur, pas par vous.
Un fichier xls en 2022, c'est tout sauf utile, vous passez juste à côté de la richesse
de vos données et de votre entreprise. Cet usage est malheureusement trop courrant
encore aujourd'hui.

Ces différences sont de taille, car si effectivement voir l'évolution de son CA est
importante, savoir si la vente de pulls rouge sur le magasin de Lyon est rentable, est
certainement plus opportun comme de connaitre la période ou vous êtes principalement
sollicité pour installer des batteries.
Ou encore de déterminer qu'un acheteur de prestation **grafana** vous restera fidèle
dans son hébergement web, plus longtemps qu'un autre ;-)

Dans les agences web, comme chez votre infogéreurs, il est possible d'acheter du
crédit temps pour de la prestation. Aussi vous pouvez certainement faire développer pour
un cout maitrisé des dashboard adaptés à votre buisness, et ça c'est aussi important.

Dans la suite de cet article, je vais vous illustrer un usage appliqué à des données
issues d'une caisse en ligne : **hiboutik**

**hiboutik** est une application web de type caisse enregistreuse. Cette application,
non libre, permet de gerer une caisse, ou des tables pour un restaurant. Vous avez la
possibilité d'avoir plusieurs points de ventes, plusieurs vendeurs, des déclinaisons
d'articles, d'afficher des grafiques de vos données plus ou moins pertinents etc... 
Là ou cette **webapp** se démarque de la concurrence, c'est que vos données sont
accessibles via une API, et téléchargeable au format **csv**

**Grafana** est capable de lire du csv, mais cela limite l'interêt du produit. Je vous
conseille d'importer vos csv dans une base **PostgreSQL**, vous profiterez du language
SQL pour filtrer et analyser vos résultats. Le SQL étant un language très répendus, il
sera toujours possible de faire évoluer vos dashboard par différents partenaires. Votre
entreprise profitera de ses investissements aussi longtemps qu'elle existera, car ils ne
seront pas soumis à votre prestataire du moment : le dashboard vous appartient, la
données aussi, et le language SQL est un standard : combo gagnante.

La requète SQL la suivante vous permez de suivre le volume par mois des ventes de Pulls.

`SELECT
  DATE_TRUNC('month',date_creation) AS "time",
  count(Libellé) AS Pull
FROM detail_ventes
WHERE Libellé like 'Pull'
group by DATE_TRUNC('month',date_creation)`

Si vous ajoutez la requète suivante à votre timeline, vous verrez le meilleur mois pour
faire la promotion des pulls et des jeans et ainsi qugmenter votre panier moyen
`SELECT
  DATE_TRUNC('month',date_creation) AS "time",
  count(Libellé) AS Jean
FROM detail_ventes
WHERE Libellé like 'Jean'
group by DATE_TRUNC('month',date_creation)`

On peut ainsi obtenir les grafiques suivants :
![répartition des commandes par ville](/static/repartition_ville.png)

![répartition du chiffre d'affaires par ville](/static/repartition_CA_ville.png)
